import Vue from 'vue'
import Router from 'vue-router'
import HelloWorld from '@/components/HelloWorld'
import Login from '@/components/Login'
import Index from '@/components/Index'
import Online from '@/components/Online'
import Records from '@/components/Records'
import Ranking from '@/components/Ranking'
import Import from '@/components/Import'
import BatchList from '@/components/BatchList'
import Time from '@/components/Time'
import Job from '@/components/Job'
import Add from '@/components/Add'

import store from '../store'

Vue.use(Router)

const router = new Router({
  routes: [
    {
      path: '/login',
      name: 'login',
      meta: {
        title: '登陆'
      },
      component: Login
    },
    {
      path: '/hello',
      name: 'hello',
      component: HelloWorld
    },
    {
      path: '/index',
      name: 'index',
      meta: {
        title: '个人中心'
      },
      component: Index
    },
    {
      path: '/online',
      name: 'online',
      meta: {
        title: '在线统计'
      },
      component: Online
    },
    {
      path: '/records',
      name: 'records',
      meta: {
        title: '今日记录'
      },
      component: Records
    },
    {
      path: '/ranking',
      name: 'Ranking',
      meta: {
        title: '排行榜'
      },
      component: Ranking
    },
    {
      path: '/import',
      name: 'Import',
      meta: {
        title: '批量导入答题'
      },
      component: Import
    },
    {
      path: '/batchList',
      name: 'BatchList',
      meta: {
        title: '批量答题列表'
      },
      component: BatchList
    },
    {
      path: '/time',
      name: 'time',
      meta: {
        title: '时间管理'
      },
      component: Time
    },
    {
      path: '/job',
      name: 'job',
      meta: {
        title: '时间管理'
      },
      component: Job
    },
    {
      path: '/add',
      name: 'add',
      meta: {
        title: '时间管理'
      },
      component: Add
    }
  ]
})

// 路由守卫 拦截
router.beforeEach((to, from, next) => {
  /* 路由发生变化修改页面title */
  if (to.meta.title) {
    document.title = to.meta.title
  }
  if (to.path !== '/login' && to.path !== '/import' && to.path !== '/batchList' && to.path !== '/time') {
    const sessionStore = JSON.parse(sessionStorage.getItem('store'))
    let jobNo = sessionStore ? sessionStore.user.userInfo.jobNo : store.state.user.userInfo.jobNo
    console.log('jobNo', jobNo)
    if (jobNo) {
      if (to.path === '/') {
        next({path: '/index'})
      }
      next()
    } else {
      next({path: '/login'})
    }
  } else {
    next()
  }
})

// 解决路由跳转重复配置
const originalPush = Router.prototype.push
Router.prototype.push = function push (location) {
  return originalPush.call(this, location).catch(err => err)
}

export default router
